; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0002
	ORG 0x0004
	RETFIE
L0002:
; 1: Hseropen 9600
;       Baud rate error: 15 (.156%)
	BSF STATUS,RP0
	MOVLW 0x40
	MOVWF SPBRG
	BSF TRISC,6
	BSF TRISC,7
	MOVLW 0x24
	MOVWF TXSTA
	BCF STATUS,RP0
	MOVLW 0x90
	MOVWF RCSTA
; 2: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 3: Dim i As Byte
;       The address of 'i' is 0x2C
	i EQU 0x2C
; 4: i = 1
	MOVLW 0x01
	MOVWF 0x2C
; 5: main: 
L0001:
; 6: Hserout "testas", CrLf
	MOVLW 0x74
	CALL HS01
	MOVLW 0x65
	CALL HS01
	MOVLW 0x73
	CALL HS01
	MOVLW 0x74
	CALL HS01
	MOVLW 0x61
	CALL HS01
	MOVLW 0x73
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 7: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 8: Goto main
	GOTO L0001
; End of program
L0003:	GOTO L0003
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x30
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Hardware Serial Communication Routines
HS01:	BTFSC PIR1,TXIF
	GOTO HS02
	GOTO HS01
HS02:	MOVWF TXREG
	RETURN
HS10:	BTFSC PIR1,RCIF
	GOTO HS11
	GOTO HS10
HS11:	MOVF RCREG,W
	RETURN
; End of listing
	END
